#include "debounce.h"

volatile uint8_t 
	buttons_down;																															//Bits is set to one if a debounced press is detected.

//Return non-zero if a button matching mask is pressed.
uint8_t button_down(uint8_t button_mask) {
  ATOMIC_BLOCK(ATOMIC_RESTORESTATE){																				//ATOMIC_BLOCK is required if debounce() is called from within an ISR
		button_mask &= buttons_down;																						//And with debounced state for a one if they match
		buttons_down ^= button_mask;																						//Clear if there was a match
  }
  return button_mask;																												//Return non-zero if there was a match
}
