'****************Listrik01 LCD Display Steuerung Version 03 *****************

'ACHTUNG: AVRISP mkII Device clock darf nicht grer 500.000 KHz sein sonst wird die CPU nicht erkannt!!

$hwstack = 256
$swstack = 256
$framesize = 128
$regfile = "m2561def.dat"                                                       'ATMEGA2561 CPU
const F_CPU = 16000000
$crystal = F_CPU

'( Siehe http://eleccelerator.com/fusecalc/fusecalc.php?chip=atmega2561
Fuse Bits:
BODLEVEL = Disabled
OCDEN = Disabled
JTAGEN = Disabled
Spien = Enabled
WDTON = Disabled
EESAVE = Enabled
BOOTSZ = 4096W_1F000
BOOTRST = Disabled
CKDIV8 = Disabled
CKOUT = Disabled
Sut_cksel = Ext.Crystal:Osc_8.0- MHz,Startuptime 16KCK+65ms

Lockbits:
All disabled

LockBit , FuseBitLow , FuseBitHigh , FuseBitExtended
')
'$prog &HFF , &HFF , &HD1 , &HFF
'( ************ Display3000, D074 Modul mit Folientastatur ************
   ---------------------
 |                     |
 |  ----------------   |
 |  |               |  |
 |  |               |  |
 |  |               |  |
 |  |               |  |
 |  |               |  |
 |  |               |  |
 |  |               |  |
 |  |               |  |
 |  |               |  |
 |  |1|    |2|      |  |  1 = Pmotlinks
 |  |---------------|  |  2 = Zyklusdauer
 |                     |
 |          Up         | Taster
 |                     |  Up   : Edit: Zeile Aufwrts bzw. Digit inkrementieren
 |       Le Ent Rt     |  Dn   : Edit: Zeile Abwrts bzw. Digit dekrementieren
 |                     |  Le   : Blttern Rckwrts bzw. zeichen links
 |          Dn         |  Rt   : Blttern Vorwrts bzw. zeichen rechts
 |  Shift         Esc  |  Ent  : Edit : EditState bzw. Werte bernehmen
 |                     |  C    : (Cancel) Editieren abbrechen
 -----------------------  Shift:
                              (Modus = 0) ==> Reset Tageskilometerzhler
                              (Modus = 3) ==> Elektrische Nulllage speichern
                                              Vorher muss der Geber-Null
                                              ungefhr richtig eingestellt sein
                              (Modus = 4) ==> Min-Maxwerte nullen
                              (Modus = 6) ==> Werte in EEPROM schreiben
                              (Modus = 7) ==> Werte in EEPROM schreiben

************ Display3000, D074 Modul mit Folientastatur ************

####################### Lcd -routines ######################################

Definition Of Used Ports And Pull Up Resistors.
We are using Port B for the SPI-communication to the LCD Display.

****** SPCR SPI CONTROL REGISTER ******
Max Frequenz erlaubt : viele MHz
Beispiel: 16MHz / 64 = 128 ==> 125KHz
Bit: 2    1    0
   SPI2X SPR1 SPR0 SCK Frequency
     0    0    0 Fosc /4
     0    0    1 fosc /16
     0    1    0 fosc /64
     0    1    1 fosc /128
     1    0    0 fosc/2   ==> doubles the clock rate
     1    0    1 fosc/8   ==> doubles the clock rate
     1    1    0 fosc/32  ==> doubles the clock rate
     1 1 1 fosc / 64 ==> doubles the clock rate

Bit2 = CPHA  CPHA: Clock Phase
Bit3 = CPOL  CPOL: Clock Polarity ==> 0 Rising Falling 1 Falling Rising

Bit4 = Mstr  Mstr : Master / Slave Select this Bit selects master Spi mode when
                  written to "1" , and slave Spi mode when written "0".
Bit5 = DORD  DORD: Data order when the DORD bit is "1", the LSB of the data word
                 is transmitted first.
Bit6 = SPE  SPE: SPI Enable
Bit7 = SPIE  SPIE: SPI Interrupt Enable

Bit      7654_3210
         |||| |||x Clockrate
         |||| ||x  Clockrate
         |||| |x   Phase = 0
         |||| x    Polarity = 0 Rising Falling (low), 1 Falling Rising(High)
         |||x      Master = Yes ==> 1
         ||x       Data Order ==> 0 Msb first, 1 LSB first
         |x        SPI Enable ==> 1
         x         Interrupt = Off ==> 0

****** SPSR SPI Status Register ******
0 = SPI2X
')

'A.0 = Input not used
'A.1 = Input not used
'A.2 = Input not used
'A.3 = Input not used
'A.4 = Input not used
'A.5 = Input not used
'A.6 = Input not used
'A.7 = Input not used
Ddra = &B0000_0000
Porta = &B1111_1111

'B.0 = CS for SD-Card
'B.1 = Output for SCK
'B.2 = Output for MOSI
'B.3 = Input for MISO
'B.4 = Output for LCD
'B.5 = Output for LCD
'B.6 = Output for LCD
'B.7 is for display lighting....
Ddrb = &B1111_0111
Portb = &B1000_1000

'C.0 = not used
'C.1 = not used
'C.2 = Input for Keypad
'C.3 = Input for Keypad
'C.4 = Input for Keypad
'C.5 = Input for Keypad
'C.6 = Input for Keypad
'C.7 = Input for Keypad
Ddrc = &B0000_0000
Portc = &B1111_1111

'D.0 Output for I2C
'D.1 Output for I2C
'D.2 Input for RX1
'D.3 Output for TX1
'D.4 Input not used
'D.5 Input not used
'D.6 Input not used
'D.7 Input not used
Ddrd = &B0000_1000
Portd = &B1111_0111

'E.0 = Input for RX0
'E.1 = Output for TX0
'E.2 = Input not used
'E.3 = Input not used
'E.4 = Input not used
'E.5 = Input not used
'E.6 = Input not used
'E.7 = Input for Keypad
Ddre = &B0000_0010
Porte = &B1111_1101

'F.0 = Input not used
'F.1 = Input not used
'F.2 = Input not used
'F.3 = Input not used
'F.4 = Input not used
'F.5 = Output for SD-Card
'F.6 = Input not used
'F.7 = Output for SD-Card
Ddrf = &B1010_0000
Portf = &B0101_1111                                                             'all pull-up-Resistors turned on

'G.0 = Input not used
'G.1 = Input not used
'G.2 = Input not used
'G.3 = Input not used
'G.4 = Input not used
'G.5 = Input not used
'G.6 = Input not used
'G.7 = Input not used
Ddrg = &B0000_0000
Portg = &B1111_1111                                                             'all pull-up-Resistors turned on

Btn_Up Alias PinC.3
Btn_Dn Alias PINC.4
Btn_Le Alias PinC.2
Btn_Rt Alias PinC.6
Btn_Ent Alias PinC.5
Btn_Esc Alias PinC.7

Btn_Shift Alias PinE.7
SD_Tristate Alias PORTF.7

'#############################################################################

Dim B as Byte

'$include "..\..\Listrik01_Common_Vars.bas"

'$Include "C:\Program Files\Tools\BASCOM-AVR\Display 3000\Displaymodul\Bascom Programme\fr Include\Init21_Display3000.bas"
'$Include "Config_mmc.bas"

$baud = 57600
$baud1 = 57600

Config Com2 = Dummy , Synchrone = 0 , Parity = None , Stopbits = 1 , _
       Databits = 8 , Clockpol = 0
OPEN "com2:" for binary as #1

Enable Interrupts

Do
  B = &H10
  Printbin #1 , B;                                                              'Daten
  waitms 10
Loop
Close #1
end

'$include "C:\Programme\Tools\BASCOM-AVR\Display 3000\Displaymodul\Bascom Programme\fr Include\GLCD21_display3000.bas"
'$include "C:\Programme\Tools\BASCOM-AVR\Display 3000\Displaymodul\Bascom Programme\fr Include\GLCD21_fonts.bas"

Colortable:
 Data 0