'****************Listrik01 LCD Display Steuerung Version 03 *****************

'ACHTUNG: AVRISP mkII Device clock darf nicht grer 500.000 KHz sein sonst wird die CPU nicht erkannt!!

$hwstack = 256
$swstack = 256
$framesize = 128
$regfile = "m2561def.dat"                                                       'ATMEGA2561 CPU

const DisplayType = "D074x"                                                     'or "D071x"

#if DisplayType = "D071x"
 const F_CPU = 16000000
#endif

#if DisplayType = "D074x"
 const F_CPU = 14745600
#endif

$crystal = F_CPU

#if DisplayType = "D071x"
 $baud1 = 57600
#endif

#if DisplayType = "D074x"
 $baud = 57600
#endif

'( Siehe http://eleccelerator.com/fusecalc/fusecalc.php?chip=atmega2561
Fuse Bits:
BODLEVEL = Disabled
OCDEN = Disabled
JTAGEN = Disabled
Spien = Enabled
WDTON = Disabled
EESAVE = Enabled
BOOTSZ = 4096W_1F000
BOOTRST = Disabled
CKDIV8 = Disabled
CKOUT = Disabled
Sut_cksel = Ext.Crystal:Osc_8.0- MHz,Startuptime 16KCK+65ms

Lockbits:
All disabled

LockBit , FuseBitLow , FuseBitHigh , FuseBitExtended
')
'$prog &HFF , &HFF , &HD1 , &HFF

'(                                                                               '                                                                               '
*************** Display3000, D071 Modul mit 9 Tastern ***************
  ---------------------
 |                     |
 | - - - - - - - - - - - - - - - - |
 |  |               |  |
 |  |               |  |
 |  |               |  |
 |  |               |  |
 |  |               |  |
 |  |               |  |
 |  |               |  |
 |  |               |  |
 |  |               |  |
 |  |               |  |
 |  | --------------|  | Display:
 |  |1|    |2|         |  1 = Pmotlinks
 |   ---------------   |  2 = Zyklusdauer
 |                     |
 |                     |
 |   O1            O2  |
 |          O5         | Taster:  Eingng = PIN,  Ausgng = PORT
 |                     |  1: PinD.7 Edit : Zeile Abwrts
 |       O7    O8      |  2: PinD.4 Edit: Zeile aufwrts
 |                     |  3: PinE.5 Blttern rckwrts
 |          O6         |  4: PinE.7 Blttern vorwrts
 |   O3            O4  |  5: PinG.0 Edit: Werte bernehmen
 |                     |  6: PinG.3 unbenutzt
 |                     |  7: PinG.1 Edit: Zahl kleiner
 |                     |     ODER
 |                     |     (Modus = 0) ==> Reset Tageskilometerzhler
 -----------------------     (Modus = 3) ==> Elektrische Nulllage speichern
                                             Vorher muss der Geber-Null
                                             ungefhr richtig eingestellt sein
                             (Modus = 4) ==> Min-Maxwerte nullen
                             (Modus = 6) ==> Werte in EEPROM schreiben
                             (Modus = 7) ==> Werte in EEPROM schreiben
                          8: PinD.5 Edit: Zahl grer
                          9 : Cpu Reset
 *************** Display3000, D071 Modul mit 9 Tastern ***************

 ************ Display3000, D074 Modul mit Joystick und 2 Tastern ************
   ---------------------
 |                     |
 |  ----------------   |
 |  |               |  |
 |  |               |  |
 |  |               |  |
 |  |               |  |
 |  |               |  |
 |  |               |  |
 |  |               |  |
 |  |               |  |
 |  |               |  |
 |  |1|    |2|      |  |  1 = Pmotlinks
 |  |---------------|  |  2 = Zyklusdauer
 |                     |
 |          Up         | Taster:  Eingng = PIN,  Ausgng = PORT
 |                     |  Up: PinC.3 Edit: Zeile Aufwrts
 |   F1  Le Pu Rt  F2  |  Dn: PinC.4 Edit: Zeile Abwrts
 |                     |  Le: PinC.5 Blttern Rckwrts
 |          Dn         |  Rt: PinC.2 Blttern Vorwrts
 |                     |  Pu: PinC.6 Edit : Werte bernehmen
 |                     |  F2: PinC.0 Edit : Zahl grer
 -----------------------  F1: PinG.1 Edit: Zahl kleiner
                                ODER
                              (Modus = 0) ==> Reset Tageskilometerzhler
                              (Modus = 3) ==> Elektrische Nulllage speichern.
                                              Vorher muss der Geber-Null
                                              ungefhr richtig eingestellt sein
                              (Modus = 4) ==> Min-Maxwerte nullen
                              (Modus = 6) ==> Werte in EEPROM schreiben
                              (Modus = 7) ==> Werte in EEPROM schreiben

 ************ Display3000, D074 Modul mit Joystick und 2 Tastern ************

####################### Lcd -routines ######################################

Definition Of Used Ports And Pull Up Resistors.
We are using Port B for the SPI-communication to the LCD Display.

****** SPCR SPI CONTROL REGISTER ******
0 = SPR0  SPR1, SPR0: SPI Clock Rate Select 1 and 0
1 = SPR1
SPI2X SPR1 SPR0 SCK Frequency
0 0 0 Fosc / 4
0 0 1 fosc /16
0 1 0 fosc /64
0 1 1 fosc /128
1 0 0 fosc /2
1 0 1 fosc /8
1 1 0 fosc /32
1 1 1 fosc /64

2 = CPHA  CPHA: Clock Phase
3 = CPOL  CPOL: Clock Polarity 0 Rising Falling 1 Falling Rising

4 = Mstr  Mstr : Master / Slave Select This Bit Selects Master Spi Mode When Written To One , And Slave Spi Mode When Written Logic Zero.
5 = DORD  DORD: Data Order When the DORD bit is written to one, the LSB of the data word is transmitted first.
6 = SPE  SPE: SPI Enable
7 = SPIE  SPIE: SPI Interrupt Enable

  7654 3210
' |---- Interrupt = Off
' ||---- SPI Enable
' |||---- Data Order = Msb ??? 1 oder 0
' ||||---- Master = Yes
' |||| |--- Polarity = Low
' |||| ||--- Phase = 0
' |||| |||--- Clockrate = 64
' |||| ||||--- Clockrate = 64
' |||| ||||
' Beispiel: Spcr = &B0101_0010

****** SPSR SPI Status Register ******
0 = SPI2X
')
#if DisplayType = "D071x"
 Ddra = &B00000000                                                              'switch all 8 Ports of Port A to input (0), Pin (PA.0 - PA.7)
 Porta = &B11111111                                                             'All port pins have individually selectable pull-up
                         'resistors. Here we enable these pull-up-resisitors, so these Pins are always at logical 1
                         'You must pull these pins to ground(gnd)

 Ddrb = &B01110110                                                              'DDR = Data direction register
                        'switched to output (1) as needed by the display
                        'B0= not used
                        'B1= Lcd_sck
                        'B2= MOSI
                        'B3= MISO
                        'B4= Lcd_reset
                        'B5= Lcd_cs
                        'B6= Lcd_dc
                        'B7= not used
 Portb = &B10111001                                                             'pull-up-Resistors turned on

 'DDR = Data direction register; Port B1, B2, B4, B5, B6 switched to output

 Ddrc = &B00000000                                                              'switch all Ports of Port C to input
 Portc = &B11111111                                                             'all pull-up-Resistors turned on

 Ddrd = &B00000000                                                              'switchall Ports of Port D to input
 Portd = &B11110011                                                             'almost all pull-up-Resistors turned on

 Ddre = &B00000000                                                              'all Input
 Porte = &B11111111                                                             'all pull-up-Resistors turned on

 Ddrf = &B10100000                                                              'F5 (SD CS) and F7=Output (SD Tristate chip activate), all other Input
 Portf = &B01011111                                                             'all pull-up-Resistors turned on

 Ddrg = &B00000000                                                              'all Ports of Port G to input
 Portg = &B11111111                                                             'all pull-up-Resistors turned on

 Btn_Up Alias Pind.7
 Btn_Dn Alias PIND.4
 Btn_Le Alias PinG.1
 Btn_Rt Alias PinG.1
 Btn_Ent Alias PinG.1
 Btn_Esc Alias PinG.1
 Btn_F1 Alias PinE.5
 Btn_F2 Alias PinE.7
 Bus_State_Rd Alias Pinf.7
 Bus_State_Wr Alias Portf.7
#endif

#if DisplayType = "D074x"
 Ddrb = &B11110111                                                              'DDR = Data direction register; Port B1, B2, B4, B5, B6 switched to output (1) as needed for display data transfer, B0 must be output for SPI master setting, B7 is for display lighting....
 Portb = &B10001000                                                             'pull-up-Resistors turned on on B.3 and B.7

 Ddra = &B00000000                                                              'switch all 8 Ports of Port A to input (0), Pin (PA.0 - PA.7)
 Porta = &B11111111                                                             'All port pins have individually selectable pull-up resistors. Here we enable these pull-up-resisitors, so these Pins are always at logical 1
                                                                                'You need to pull these Pins against ground (GND)

 Ddrc = &B00000000                                                              'switch all Ports of Port C to input
 Portc = &B11111111                                                             'all pull-up-Resistors turned on

 Ddrd = &B00001011                                                              'D.0 and D.1 to output for IC (needed for communication with Real Time Clock) - if IC is not needed, set to "0"
                                                                                'D.3 is TX1, thus needs to be output. If UART1 is not used, set to "0"
 Portd = &B11111100                                                             'pull-up-Resistors turned on

 Ddre = &B00000010                                                              'E.1 is TX0, thus needs to be output. If UART0 is not used, set to "0"
 Porte = &B11111111                                                             'all pull-up-Resistors turned on

 Ddrf = &B10100000                                                              'F.5 and F.7 are needed as outputs for SD card. If no SD card is used, set to "0"
 Portf = &B01011111                                                             'pull-up-Resistors turned on

 Ddrg = &B00000000                                                              'switch all Ports of Port G to input
 Portg = &B11111111                                                             'all pull-up-Resistors turned on

 Btn_Up Alias PinC.4
 Btn_Dn Alias PINC.3
 Btn_Le Alias PinC.2
 Btn_Rt Alias PinC.5
 Btn_Ent Alias PinC.1
 Btn_Esc Alias PinC.6
 Btn_F1 Alias PinC.1
 Btn_F2 Alias PinC.0
 Bus_State_Rd Alias Pinf.7
 Bus_State_Wr Alias Portf.7
#endif
'#############################################################################

Declare Sub Activate_display_bus
Declare Sub Activate_SD_Bus
Declare Sub Minmax
declare Sub DrawPageStatics(Byval PageNum as Byte)
Declare Sub DisplayLine(t As String , Byval X As Byte , Byval Y As Byte , _
                        Byval Txtcolor As Word , Byval Bgrcolor As Word)
Declare Sub DisplayStatusLine(Txt As String , Byval X As Byte , Byval Y As Byte , _
                              Byval Txtcolor As Word , Byval Bgrcolor As Word)
Declare Sub ChangeDecimal(byval Up As Byte)
Declare Sub SendMessage2COM
Declare Sub GetEEpromData
Declare Sub PutEEpromData
Declare Sub DisplayEditLine(byval ConstStr as String , Variable as Long)
Const Titel = "Tacho 1.0  Page:"

$include "..\..\Listrik01_Common_Vars.bas"

'**** Sendepuffer ****
Const TxBuffMax = 70
Dim LongTxData(TxBuffMax) as Byte                                               'Parameter an Main
'**** Sendepuffer ****

'**** Empfangspuffer ****
Dim Ep0 As Byte                                                                 'CR
Dim Ep1 As Byte                                                                 'Adresse
Dim Ep2 As Byte                                                                 'Richtung
Dim Ep3 As Byte                                                                 'PWM
Dim Ep4 As Byte                                                                 'RxSubParIndex
Dim Ep5 As Byte                                                                 'RxSubParData
Dim Ep6 As Byte                                                                 'RxSubParData
Dim Ep7 As Byte                                                                 'RxSubParData
Dim Ep8 As Byte                                                                 'RxSubParData
Dim Ep9 As Byte                                                                 'BCC
Dim Ep10 As Byte                                                                'CR

'**** Empfangspuffer ****

Dim Mit_Acc_Nick As Long                                                        'Nick
Dim Mit_AccNick As Long
Dim Mit_AccNick1 As Byte At Mit_AccNick + 0 Overlay
Dim Mit_AccNick2 As Byte At Mit_AccNick + 1 Overlay
Dim Mit_AccNick3 As Byte At Mit_AccNick + 2 Overlay
Dim Mit_AccNick4 As Byte At Mit_AccNick + 3 Overlay

Dim Nick_Offset As Long
Dim NickOffset As Long
Dim NickOffset1 As Byte At NickOffset + 0 Overlay
Dim NickOffset2 As Byte At NickOffset + 1 Overlay
Dim NickOffset3 As Byte At NickOffset + 2 Overlay
Dim NickOffset4 As Byte At NickOffset + 3 Overlay

Dim Null_Nick As Long
Dim NullNick As Long
Dim NullNick1 As Byte At NullNick + 0 Overlay
Dim NullNick2 As Byte At NullNick + 1 Overlay
Dim NullNick3 As Byte At NullNick + 2 Overlay
Dim NullNick4 As Byte At NullNick + 3 Overlay

Dim Sw As Single
Dim Sw1 As Byte At Sw + 0 Overlay
Dim Sw2 As Byte At Sw + 1 Overlay
Dim Sw3 As Byte At Sw + 2 Overlay
Dim Sw4 As Byte At Sw + 3 Overlay

$include "..\..\Msg_Display2MainCtrl_COM.bas"

Dim ErrorWord As Word
Dim ErrorWord1 As Byte At ErrorWord + 0 Overlay
Dim ErrorWord2 As Byte At ErrorWord + 1 Overlay

Dim Sinus(12) As Byte                                                           'Fr den Motorcontroller

'Gespiegelte Daten vom Motorcontroller
Dim Ruecksinuslinks(12) As Byte
Dim StromRegPfaktor as Integer
Dim StromRegIfaktor as Integer
Dim StromGrenze as Word

Dim Rueck_O_nick_u as Long
Dim Rueck_Onicku as Long
Dim Rueck_Onicku1 as Byte at Rueck_Onicku + 0 overlay
Dim Rueck_Onicku2 as Byte at Rueck_Onicku + 1 overlay
Dim Rueck_Onicku3 as Byte at Rueck_Onicku + 2 overlay
Dim Rueck_Onicku4 as Byte at Rueck_Onicku + 3 overlay

Dim Rueck_O_nick_o as Long
Dim Rueck_Onicko as Long
Dim Rueck_Onicko1 as Byte at Rueck_Onicko + 0 overlay
Dim Rueck_Onicko2 as Byte at Rueck_Onicko + 1 overlay
Dim Rueck_Onicko3 as Byte at Rueck_Onicko + 2 overlay
Dim Rueck_Onicko4 as Byte at Rueck_Onicko + 3 overlay

Dim Rueck_O_nick_oo as Long
Dim Rueck_Onickoo as Long
Dim Rueck_Onickoo1 as Byte at Rueck_Onickoo + 0 overlay
Dim Rueck_Onickoo2 as Byte at Rueck_Onickoo + 1 overlay
Dim Rueck_Onickoo3 as Byte at Rueck_Onickoo + 2 overlay
Dim Rueck_Onickoo4 as Byte at Rueck_Onickoo + 3 overlay

Dim RueckRegelstrategie as Byte

Dim RueckPWMmax as Byte

Dim RueckStromgrenze as Word
Dim RueckStromgrenze1 as Byte at RueckStromgrenze + 0 Overlay
Dim RueckStromgrenze2 as Byte at RueckStromgrenze + 1 Overlay

Dim RueckStromReg_Pfaktor as Single
Dim RueckStromReg_Pfaktor1 as Byte at RueckStromReg_Pfaktor + 0 Overlay
Dim RueckStromReg_Pfaktor2 as Byte at RueckStromReg_Pfaktor + 1 Overlay
Dim RueckStromReg_Pfaktor3 as Byte at RueckStromReg_Pfaktor + 2 Overlay
Dim RueckStromReg_Pfaktor4 as Byte at RueckStromReg_Pfaktor + 3 Overlay

Dim RueckStromReg_Ifaktor as Single
Dim RueckStromReg_Ifaktor1 as Byte at RueckStromReg_Ifaktor + 0 Overlay
Dim RueckStromReg_Ifaktor2 as Byte at RueckStromReg_Ifaktor + 1 Overlay
Dim RueckStromReg_Ifaktor3 as Byte at RueckStromReg_Ifaktor + 2 Overlay
Dim RueckStromReg_Ifaktor4 as Byte at RueckStromReg_Ifaktor + 3 Overlay

Dim RueckOffset_Nick as Long
Dim RueckOffsetNick as Long
Dim RueckOffsetNick1 as Byte at RueckOffsetNick + 0 overlay
Dim RueckOffsetNick2 as Byte at RueckOffsetNick + 1 overlay
Dim RueckOffsetNick3 as Byte at RueckOffsetNick + 2 overlay
Dim RueckOffsetNick4 as Byte at RueckOffsetNick + 3 overlay

Dim RueckIstRichtung as Byte

Dim RueckLoopCount as Word
Dim RueckLoopCount1 as Byte at RueckLoopCount + 0 Overlay
Dim RueckLoopCount2 as Byte at RueckLoopCount + 1 Overlay

Dim RueckAusgabeTicks_L as Integer                                              'Anzahl Kommutierungen je 10mS, linker Motor
Dim RueckAusgabeTicks_L1 as Byte at RueckAusgabeTicks_L + 0 Overlay
Dim RueckAusgabeTicks_L2 as Byte at RueckAusgabeTicks_L + 1 Overlay

'***** Variablen fr den Editor. Singles zu Long gewandelt *****
Dim Pfaktor As Long
Dim Ifaktor As Long
Dim Dfaktor As Long
Dim Mpfaktor As Long
Dim Mvfaktor As Long
Dim Mplfaktor As Long
Dim Mvlfaktor As Long
'***** Variablen fr den Editor. Singles zu Long gewandelt *****

Dim Gyro_nick As Long
Dim K_sum As Single
Dim K_summax As Single
Dim K_summin As Single
Dim Bdummy As Byte
Dim Bdummy1 As Byte
Dim Bdummy2 As Byte
Dim Bdummy3 As Byte
Dim Singdummy As Single
Dim Ldummy As Long
Dim Idummy As Integer
Dim Idummy1 As Byte

Dim KmhMax As Integer
Dim KmhMin As Integer

Dim IBattMax as Byte                                                            'Batteriestrom in A. Beispiel: 22 fr 22A

Dim I As Integer
Dim Imax As Integer
Dim Imin As Integer

Dim U As Integer
Dim U1 As Byte at U + 0 Overlay
Dim U2 As Byte at U + 1 Overlay
Dim Umax As Integer
Dim Umin As Integer

'Dim PWM_Links As Byte Siehe Variable "SollSpeed"

Dim PWM_Links_Max As Integer
Dim PWM_Links_Min As Integer
Dim Modus As Byte
Dim EditZeile As Byte
Dim Utext As String * 22
Dim Itext As String * 22
Dim Ltext As String * 22
Dim L1 As Byte
Dim L2 As Byte
Dim Text As String * 22
Dim Farbe As Word
Dim X1 As Byte
Dim Y1 As Byte
Dim X2 As Byte
Dim Y2 As Byte
Dim Startkilometer As Single
Dim Ta As Byte
Dim Tamax As Byte
Dim Ya As Byte
Dim Xa As Byte
Dim Lname As Long
Dim Dateiname As String * 12
Dim Dateilaenge As Long
Dim DateiAktuell As Byte
Dim Loopcount As Word
Dim Aloopcount As Word
Dim Logtext As String * 255
Dim Zeit As String * 8
Dim FussSchalter As Byte
Dim FussCount As Byte

Dim Dummybyte As Byte
Dim ErrorStr(17) As String * 22
Dim NotAusGrundStr(8) As String * 22
Dim Errorindex As Byte

Dim MessageStr(2) As String * 22
Dim MsgStrIndex as Byte

Dim KK_Temp_Links as Integer
Dim KK_Temp_Links1 as Byte at KK_Temp_Links + 0 Overlay
Dim KK_Temp_Links2 as Byte at KK_Temp_Links + 1 Overlay

Dim Comerrorsmotlinks As Word
Dim ComerrorsMotlinks1 As Byte At ComerrorsMotlinks + 0 Overlay
Dim ComerrorsMotlinks2 As Byte At ComerrorsMotlinks + 1 Overlay

Dim Comerrorsdisplay As Word
Dim Comerrorsdisplay1 As Byte At Comerrorsdisplay + 0 Overlay
Dim Comerrorsdisplay2 As Byte At Comerrorsdisplay + 1 Overlay

Dim Akkuverbraucht As Integer
Dim Akkuverbraucht1 As Byte At Akkuverbraucht + 0 Overlay
Dim Akkuverbraucht2 As Byte At Akkuverbraucht + 1 Overlay

Dim Startup As Word
Dim Startup1 As Byte At Startup + 0 Overlay
Dim Startup2 As Byte At Startup + 1 Overlay

Dim FirstRun as Byte

Dim VLimit as Byte
Dim RueckVLimit as Byte

Dim Regelstrategie as Byte
Dim SollRichtung as Byte
Dim SollSpeed as Byte
Dim NotausGrund As Byte
Dim StartupStr(10) As String * 22

'***** EEprom *****
Dim Dummy As Eram Byte                                                          'offset &H00
Dim EStartkilometer As Eram Single
Dim ENick_Offset As Eram Long
Dim ESinus(12) As Eram Byte
Dim EIBattMax As Eram Byte                                                      '30 = 30A
Dim EP_faktor As Eram Single
Dim EI_faktor As Eram Single
Dim ED_faktor As Eram Single
Dim EMp_faktor As Eram Single
Dim EMv_faktor As Eram Single
Dim EMpl_faktor As Eram Single
Dim EMvl_faktor As Eram Single
Dim ERegelStrategie as Eram Byte
Dim EPWMmax as Eram Byte
Dim EStromReg_Pfaktor as Eram Single
Dim EStromReg_Ifaktor as Eram Single
Dim EStrom_Grenze as Eram Byte                                                  '30 = 30A
Dim EVLimit as Eram Byte
'***** EEprom *****

'***** Edit Number *****
Dim EditStr as String * 22
Dim EditState as Byte                                                           '0 = Select Line , 1 = Sel / Mod Decimal
Dim Zeile as Byte
Dim Spalte as Byte
'***** Edit Number *****

Dim TTempStr as string * 22
Dim OK_Str as String * 19
Dim Error_Str as String * 19
'                0000000001111111111   max 19 Zeichen. Nicht mehr Platz auf Page 0
'                1234567890123456789
OK_Str = "Alles OK"
Error_Str = "Fehler stehen an"

'                    0000000001111111111222   max 22 Zeichen
'                    1234567890123456789012
StartupStr(1) = "Start-Taste entlastet "
StartupStr(2) = "Kopplung z. Motorcontr"
StartupStr(3) = "Futaster entlastet   "
StartupStr(4) = "Antrieb ist AUS       "
StartupStr(5) = "Systemspannung in Tol."
StartupStr(6) = "Parameter OK          "
StartupStr(7) = "Sensoren in Mittellage"
StartupStr(8) = "Futaster belastet    "
StartupStr(9) = "Reset-Taste bettigt  "
StartupStr(10) = "Bitte aufsteigen      "

ErrorStr(1) = "Spannung ist < 24V"                                              'Errorword.0
ErrorStr(2) = "Spannung ist < 36V"                                              'Errorword.1
ErrorStr(3) = "Spannung ist < 48V"                                              'Errorword.2
ErrorStr(4) = "Warte Gyros Nullen"                                              'Errorword.3
ErrorStr(5) = "Warte auf Fuschal"                                              'Errorword.4
ErrorStr(6) = "Antrieb ist AUS"                                                 'Errorword.5
ErrorStr(7) = "NOT AUS steht an"                                                'Errorword.6
ErrorStr(8) = "Rx Timeout MotCtrl"                                              'Errorword.7
ErrorStr(9) = "Mot.Hallst. fehlt"                                               'Errorword.8
ErrorStr(10) = "Mot.Strombeg.aktiv"                                             'Errorword.9
ErrorStr(11) = "Motor hat NOTAUS"                                               'Errorword.10
ErrorStr(12) = "Rx Timeout Display"                                             'Errorword.11
ErrorStr(13) = "not used 12      "                                              'Errorword.12
ErrorStr(14) = "not used 13      "                                              'Errorword.13
ErrorStr(15) = "not used 14      "                                              'Errorword.14
ErrorStr(16) = "not used 15      "                                              'Errorword.15

NotAusGrundStr(1) = "Fussch.zulange frei"                                       'Notausgrund.0
NotAusGrundStr(2) = "Ausregelzt zu. lang"                                       'Notausgrund.1
NotAusGrundStr(3) = "Zuweit n. vorne gek"                                       'Notausgrund.2
NotAusGrundStr(4) = "Zuweit n.hinten gek"                                       'Notausgrund.3
NotAusGrundStr(5) = "Halltest Fehler"                                           'Notausgrund.4
NotAusGrundStr(6) = "berstrom"                                                 'Notausgrund.5
NotAusGrundStr(7) = "Rx Timeout Motor"                                          'Notausgrund.6

MessageStr(1) = "Unfallschreiber"
MessageStr(2) = "Betriebsschreiber"

Modus = 255

Config Clock = User
Config Date = Dmy , Separator = .

$Include "C:\Program Files\Tools\BASCOM-AVR\Display 3000\Displaymodul\Bascom Programme\fr Include\Init21_Display3000.bas"
$Include "C:\Program Files\Tools\BASCOM-AVR\Display 3000\Displaymodul\Bascom Programme\SD Speicherkartenmodul P001\Bascom Basic\CONFIG_AVR-DOS.bas"
$include "C:\Program Files\tools\BASCOM-AVR\Display 3000\Displaymodul\Bascom Programme\fr Include\Config_mmc_Display_walter.bas"

Orientation = Portrait180

' #############################################################################
' ### Set up time for PWM control (for display dimming)      ##################
' #############################################################################
'(
Config Timer1 = Pwm , Pwm = 8 , Compare C Pwm = Clear Up , _
                Compare C Pwm = Clear Down , Prescale = 64                      'Prescale of 256 might flicker with 8 Mhz modules
Pwm1c = 255                                                                     'starts with 255 = lights OFF
')
GbDriveError = 1

If Porte.7 = 1 Then Call Activate_sd_bus
Gbdriveerror = Driveinit()                                                      'Init MMC/SD Card
If Gbdriveerror = 0 Then
 Bdummy = InitFileSystem(1)                                                     'Partition 1
 Ldummy = Disksize()
 Ldummy = Ldummy / 1024
 Utext = Str(ldummy)
 Utext = "Size: " + Utext
 Utext = Utext + " MB"
 Ldummy = Diskfree()
 Ldummy = Ldummy / 1024
 Itext = Str(ldummy)
 Itext = "Free: " + Itext
 Itext = Itext + " MB"
Else
 Ltext = Str(gbdriveerror)
 Ltext = "Fehler: " + Ltext
End If

If Porte.7 = 0 Then Call Activate_Display_Bus

Text = "Listrik01"                                                              'zentriert, gro
L1 = Len(Text)
Text = Text + " "
L1 = L1 * 4
X1 = 66 - L1
LCD_Print Text , X1 , 16 , 2 , 1 , 2 , Black , White

Text = "Walter Software"                                                        'zentriert, klein
L1 = Len(Text)
Text = Text + " "
L1 = L1 * 3
X1 = 66 - L1
LCD_Print Text , X1 , 50 , 1 , 1 , 1 , Black , White

Text = "Version 01, Rev.0"                                                      'zentriert, klein
L1 = Len(Text)
Text = Text + " "
L1 = L1 * 3
X1 = 66 - L1
LCD_Print Text , X1 , 70 , 1 , 1 , 1 , Black , White

LCD_Print "SD-Karte init" , 0 , 90 , 1 , 1 , 1 , Black , White
If Gbdriveerror = 0 Then
 LCD_Print Utext , 0 , 99 , 1 , 1 , 1 , Black , White
 LCD_Print Itext , 0 , 108 , 1 , 1 , 1 , Black , White
else
 LCD_Print Ltext , 0 , 99 , 1 , 1 , 1 , Black , White
end if

'display dimming
'(
Call Lcd_print( "TFT Brightness:" , 0 , 140 , 1 , 1 , 1 , Blue , White)
 Call Lcd_print( "000%" , 50 , 160 , 2 , 1 , 1 , Blue , White)
 Waitms 300
 For Bdummy1 = 255 To 0 Step -5
  Pwm1c = Bdummy1
  Waitms 20
  Singdummy = Bdummy1 * 0.39
  Bdummy2 = Singdummy
  Bdummy2 = 100 - Bdummy2
  Text = Str(Bdummy2)
  Text = Format(Text , "000")
  Text = Text + "%"
  Call Lcd_print(Text , 50 , 160 , 2 , 1 , 1 , Blue , White)
Next
')
Call GetEEpromData

'Einige Werte vorbelegen um fehlerhafte Grafik zu vermeiden falls keine
'serielle Verbindung besteht
Xa = 74
Ya = 130

Config Timer2 = Timer , Prescale = 128
Assr.exclk = 0
Assr.as2 = 1

On Timer2 Tick
Enable Timer2

#if DisplayType = "D071x"
 Open "COM2:" For Binary As #1
 On Urxc1 Datenempfang
 Enable Urxc1
#endif

#if DisplayType = "D074x"
 On Urxc Datenempfang
 Enable Urxc
#endif

Enable Interrupts

Call Minmax
Modus = 0

Wait 2                                                                          '2 Seconds for Startup Display

If Bus_State_Rd = 0 Then Call Activate_display_bus
Call Lcd_cls()

Call Drawpagestatics(Modus)
FirstRun = 1

Do
 Select Case EditState
  Case 0
   If Btn_Ent = 0 Then                                                          'bernehmen
    Waitms 3
    If Btn_Ent = 0 Then While Btn_Ent = 0 : Wend
    Select Case Modus
     Case 5
      Select Case Zeile
        Case 1
         EditStr = val(P_faktor)
        Case 2
         EditStr = val(I_faktor)
        Case 3
         EditStr = val(D_faktor)
        Case 4
         EditStr = val(Mp_faktor)
        Case 5
         EditStr = val(Mv_faktor)
        Case 6
         EditStr = val(Mpl_faktor)
        Case 7
         EditStr = val(Mvl_faktor)
        Case 8
         EditStr = val(V_limit)
        Case 9
         EditStr = val(Regelstrategie)
      end select
     Case 6
      Select Case Zeile
        Case 1
         EditStr = val(StromRegPfaktor)
        Case 2
         EditStr = val(StromRegIfaktor)
        Case 3
         EditStr = val(StromGrenze)
        Case 4
         EditStr = val(PWMmax)
        Case 5                                                                'I-Batterie Max
         EditStr = val(IBattMax)                                                '1A Schritte
      end select
    end select
    EditMode = 1
   end if

   If Btn_Esc = 0 Then                                                          'abbrechen
     Waitms 3
     If Btn_Esc = 0 Then While Btn_Esc = 0 : Wend
     EditMode = 0
     EditStr = ""                                                               ''                                                                ''
   end if

   If Btn_F2 = 0 Then                                                           'Blttern vorwrts
    While Btn_F2 = 0 : Wend                                                     'Debounce Button
    Incr Modus
    EditZeile = 0
    If Gbdriveerror <> 0 then                                                   'Logging nur wenn Antrieb luft
     If Modus >= 10 Then Modus = 0                                              'Skip modes 10 and 11
    elseif Antriebaus = 1 then
     If Modus >= 11 Then Modus = 0                                              'Skip mode 11
    Else
     If Modus > 11 Then Modus = 0
    End If

    If Bus_State_Rd = 0 Then Call Activate_display_bus
    Call Lcd_cls
    Call Drawpagestatics(Modus)
   End If

   If Btn_F1 = 0 Then                                                           'Blttern rckwrts
    While Btn_F1 = 0 : Wend                                                     'Debounce Button
    If Modus > 0 Then
     Decr Modus
    Else
     If Gbdriveerror <> 0 Then                                                  'Logging nicht zulassen wenn DriveError
      Modus = 9                                                                 'Skip modes 10 and 11
     elseif Antriebaus = 1 then
      Modus = 10
     Else
      Modus = 11
     End If
    End If
    EditZeile = 0
    If Bus_State_Rd = 0 Then Call Activate_display_bus
    Call Lcd_cls
    Call Drawpagestatics(Modus)
   End If

   'Min/Max Werte speichern
   If Modus <> 11 Then                                                          'Nur wenn nicht geloggt wird
    If U <> 0 and Ta <> 0 Then                                                  'Nur wenn auch schon eine Spannung und ein Ta bertragen wurden
     If U > Umax Then Umax = U
     If U < Umin Then Umin = U

     If I > Imax Then Imax = i
     If I < Imin Then Imin = I

     If Kmh > KmhMax Then KmhMax = Kmh
     If Kmh < KmhMin Then KmhMin = Kmh

     If Ta > Tamax Then Tamax = Ta

     If SollSpeed > PWM_Links_Max Then PWM_Links_Max = SollSpeed
     If SollSpeed < PWM_Links_Min Then PWM_Links_Min = SollSpeed
    End If
   End If

  Case 1                                                                        'Wert editieren
   If Btn_Le = 0 Then                                                           'Zahl dekrementieren
    Waitms 3
    If Btn_Le = 0 Then
     While Btn_Le = 0 : Wend
     If Spalte > 1 then Decr Spalte
    End If
   End If

   If Btn_Rt = 0 Then                                                           'Zahl inkrementieren
    Waitms 3
    If Btn_Rt = 0 Then
     While Btn_Rt = 0 : Wend
     If Spalte < len(EditStr) then Incr Spalte
    End If
   End If

   If Btn_Esc = 0 Then                                                          'abbrechen
    Waitms 3
    If Btn_Esc = 0 Then While Btn_Esc = 0 : Wend
    EditMode = 0
   end if

   If Btn_Ent = 0 Then                                                          'bernehmen
    Waitms 3
    If Btn_Ent = 0 Then While Btn_Ent = 0 : Wend
    Select Case Mode
     Case 0
       'nothing to edit
     Case 1
       'nothing to edit
     Case 2
       'nothing to edit
     Case 3
       'nothing to edit
     Case 4
       'nothing to edit
     Case 5
       Select Case Zeile
        Case 1
         P_faktor = val(EditStr)
        Case 2
         I_faktor = val(EditStr)
        Case 3
         D_faktor = val(EditStr)
        Case 4
         Mp_faktor = val(EditStr)
        Case 5
         Mv_faktor = val(EditStr)
        Case 6
         Mpl_faktor = val(EditStr)
        Case 7
         Mvl_faktor = val(EditStr)
        Case 8
         V_limit = val(EditStr)
        Case 9
         Regelstrategie = val(EditStr)
       end select
     Case 6
       Select Case Zeile
        Case 1
         StromRegPfaktor = val(EditStr)
        Case 2
          StromRegIfaktor = val(EditStr)
        Case 3
          StromGrenze = val(EditStr)
        Case 4
          PWMmax = val(EditStr)
        Case 5                                                                  'I-Batterie Max
          IBattMax = val(EditStr)                                               '1A Schritte
       end select

     Case 7
        Sinus(Zeile) = val(EEditStrditText)

     Case 8
        'nothing to edit

     Case 9
        'nothing to edit

     Case 10
        'nothing to edit

     Case 11
        'nothing to edit
    end select
    EditMode = 0                                                                'end of edit mode
   end if
 end select

 Select Case Modus
 Case 0                                                                         'Startup
  Bdummy3 = 0
  For Bdummy2 = 1 To 10
   Text = StartupStr(bdummy2)
   Bdummy1 = Bdummy2 * 9                                                        'Position der Textzeile festlegen
   Bdummy1 = Bdummy1 + 20                                                       'Titelzeile bercksichtigen
   If Startup.Bdummy3 > 0 Then
    Call DisplayLine(Text , 0 , Bdummy1 , Black , Green)
   Else
    Call DisplayLine(Text , 0 , Bdummy1 , Black , White)
   End If
   Incr Bdummy3
  Next

  'alle Bedingungen sind erfllt. Umschalten auf Hauptdisplay
  If FirstRun = 1 and Startup.9 = 1 Then
   Modus = 1
   FirstRun = 0
   Call Lcd_cls
   Call Drawpagestatics(Modus)
  End If

 Case 1                                                                         'Hauptdisplay
   If DateiAktuell = 1 Then
    If Bus_State_Rd = 1 Then Activate_sd_bus
    Close #2
    DateiAktuell = 0
   End If
   If Bus_State_Rd = 0 Then Call Activate_display_bus                           'Standard Anzeige

   If Btn_Pu = 0 Then                                                           'Tageskilomerterzhler nullen
    Waitms 3
    If Btn_Pu = 0 Then
     While Btn_Pu = 0 : Wend
     Singdummy = Meter / 1000
     Singdummy = Singdummy + Kilometer
     Startkilometer = Singdummy
     EStartkilometer = Startkilometer
    End If
   End If

   'Spannung und Strom
   Singdummy = U / 100
   Utext = Fusing(Singdummy , "#.&")
   Utext = Utext + "V"
   Utext = " " + Utext

   SingDummy = I / 10
   Itext = Fusing(SingDummy , "#.&") + "A "

   L1 = Len(utext)
   L2 = Len(itext)
   L1 = L1 + L2
   L2 = 22 - L1
   Ltext = String(l2 , 32)
   Text = Utext + Ltext
   Text = Text + Itext
   LCD_Print Text , 0 , 75 , 1 , 1 , 1 , Black , White

   'Akku in Prozent
   Singdummy = AkkuStand
   Singdummy = 100 - Singdummy                                                  '%
   Idummy = Singdummy
   Text = Str(Idummy)                                                           '00...100%
   Text = " " + Text + "% "
   If Idummy > 66 Then
    Farbe = Green
   Elseif Idummy > 33 Then
    Farbe = Yellow
   Else
    Farbe = Red
   End If
   Singdummy = Singdummy * 1.14                                                 '124 - 8 - 1 - 1 = 114 / 100% = 1.14
   X2 = Singdummy                                                               'Typecast
   X2 = X2 + 10                                                                 '10 wegen der "100 - Sdummy" weiter oben
   If X2 > 123 Then X2 = 123
   If X2 < 9 Then X2 = 9
   Lcd_box X2 , 85 , 123 , 94 , White                                           'Hintergrund lschen
   Lcd_box 9 , 85 , X2 , 94 , Farbe                                             'Balken zeichnen
   'Text mittig platzieren
   L1 = Len(Text)
   L1 = L1 * 5
   L1 = L1 / 2
   X1 = 66 - L1
   LCD_Print Text , X1 , 98 , 1 , 1 , 1 , Black , White                         'unterm Balken

   'Km/h
   Singdummy = Kmh / 10
   Text = Fusing(Singdummy , "#.&")
   'Text = Str(Idummy)
   Text = Text + "Kmh "
   Text = " " + Text
   L1 = Len(Text)
   Text = Text + " "
   L1 = L1 * 4
   X1 = 66 - L1
   LCD_Print Text , X1 , 12 , 2 , 1 , 2 , Black , White

   'km
   Singdummy = Meter / 1000
   Singdummy = Singdummy + Kilometer
   Text = Fusing(Singdummy , "#.&")
   Text = Text + "km  "
   Text = " " + Text
   L1 = Len(Text)
   L1 = L1 * 5
   L1 = L1 / 2
   X1 = 66 - L1
   LCD_Print Text , X1 , 46 , 1 , 1 , 1 , Black , White

   'Tageskilometerzhler
   Singdummy = Singdummy - Startkilometer
   Text = Fusing(singdummy , "#.###")
   Text = Text + "km  "
   Text = " " + Text
   L1 = Len(Text)
   L1 = L1 * 5
   L1 = L1 / 2
   X1 = 66 - L1
   LCD_Print Text , X1 , 60 , 1 , 1 , 1 , Black , White

   'Motortemperaturen
   Singdummy = KK_Temp_Links / 10
   Text = "KK-Temp:" + Fusing(Singdummy , "#.#")
   Text = Text + "C"
   LCD_Print Text , 25 , 115 , 1 , 1 , 1 , Black , White

   'Antrieb Status
   Text = "Status: "
   If AntriebAus = 1 Then
    Text = Text + "AUS"
   Else
    Text = Text + "RUN"
   end if
   LCD_Print Text , 25 , 124 , 1 , 1 , 1 , Black , White

   'Gyros in Nullposition
   If AntriebAus = 1 and Errorword.3 > 0 Then
    LCD_Print "Gyros in Nullpos." , 25 , 133 , 1 , 1 , 1 , White , Black
   else
    LCD_Print "" , 25 , 133 , 1 , 1 , 1 , Black , White
   end if

   '############ Alles in Zeile 156 ############
   If ErrorWord > 0 or NotausGrund > 0 then
    Call DisplayStatusLine(Error_Str , 20 , 156 , Black , White)                'OK
   else
    Call DisplayStatusLine(OK_Str , 20 , 156 , Black , White)                   'OK
   end if

   Select case MsgStrIndex
    'Case 0:  'Alles OK
    Case 1 : Call DisplayStatusLine(MessageStr(1) , 20 , 156 , Black , White)   'UnfallDatenSchreiber
    Case 2 : Call DisplayStatusLine(MessageStr(2) , 20 , 156 , Black , White)   'BetriebsDatenSchreiber
   end select
   '############ Alles in Zeile 156 ############

   '>>>>>>>>>>>> Fusszeile im Display >>>>>>>>>>>>
   '  00000000001111111111222
   '  01234567890123456789012
   '  xxx       xxx
   '   Ta     SollSpeed

   Text = Str(Ta) + "   "                                                       'Ticks
   LCD_Print Text , 0 , 168 , 1 , 1 , 1 , Black , White

   Text = Str(SollSpeed) + "   "                                                'PWM_Links
   LCD_Print Text , 45 , 168 , 1 , 1 , 1 , Black , White

   '>>>>>>>>>>>> Nick Balken <<<<<<<<<<<<<
   If Antriebaus = 1 Then
    '30 Grad ==> 102300
    ' 5 Grad ==> 8525
    '8525 counts / 29 Pixel = 294 Counts per Pixel
    Singdummy = Null_Nick
    Singdummy = Singdummy - Nick_Offset
    Singdummy = Singdummy / 294
    If Singdummy > 29 Then
     Singdummy = 29
    elseIf Singdummy < -29 Then
     Singdummy = -29
    end if
    Singdummy = Singdummy + 130
    Y1 = Singdummy                                                              'Mitten Offset
    LCD_Draw 9 , Ya , 18 , Ya , 0 , White
    LCD_Draw 9 , Y1 , 18 , Y1 , 0 , Black
    Ya = Y1
   Else
    '30 Grad ==> 51200
    '10 Grad ==> 17066 Full Scale
    'Balkenlnge = 29 = 58 Pixel
    '8533 counts / 29 Pixel = 294,2 Counts per Pixel
    Singdummy = Mit_Acc_Nick / 294
    If Singdummy > 29 Then
     Singdummy = 29
    elseIf Singdummy < -29 Then
     Singdummy = -29
    end if
    Singdummy = Singdummy + 130
    Y1 = singdummy
    LCD_Draw 9 , Ya , 18 , Ya , 0 , White
    LCD_Draw 9 , Y1 , 18 , Y1 , 0 , Black
    Ya = Y1
  End If

 Case 2                                                                         'Fehlermeldungen und Motor Notaus Kriterien
  Bdummy2 = 11
  For Idummy = 0 To 15                                                          'Errorword.0 ==> ErrorStr(1)
   If Errorword.Idummy > 0 Then
    IDummy1 = Idummy + 1
    Text = "E" + Str(Idummy) + ":"
    Text = Text + ErrorStr(Idummy1)
    Bdummy2 = Bdummy2 + 9                                                       'Grafikzeile
    If BDummy2 < 130 then Call DisplayLine(Text , 0 , Bdummy2 , Black , White)
   End If
  Next

  For Idummy = 0 To 5
   If NotausGrund.Idummy > 0 Then
    IDummy1 = Idummy + 1
    Text = "N" + Str(Idummy) + ":"
    Text = Text + NotausGrundStr(Idummy1)
    Bdummy2 = Bdummy2 + 9                                                       'Grafikzeile
    If BDummy2 < 130 then Call DisplayLine(Text , 0 , Bdummy2 , Black , White)
   end if
  Next

  While BDummy2 < 112                                                           'Clear lines
   Text = "                "
   Bdummy2 = Bdummy2 + 9                                                        'Grafikzeile
   Call DisplayLine(Text , 0 , Bdummy2 , Black , White)
  wend

  Text = "ComErr2MotL:" + Str(ComErrorsMotLinks)
  Call DisplayLine(Text , 0 , 157 , Black , White)

  Text = "ComErr2Disp:" + Str(ComErrorsDisplay)
  Call DisplayLine(Text , 0 , 166 , Black , White)

 Case 3                                                                         'Detail Display
  If DateiAktuell = 1 Then
   If Bus_State_Rd = 1 Then Activate_sd_bus
   Close #2
   DateiAktuell = 0
  End If

  If Bus_State_Rd = 0 Then Call Activate_display_bus

  If Btn_Pu = 0 Then                                                            'Neigung Nullen
   Waitms 3
   If Btn_Pu = 0 Then
    While Btn_Pu = 0 : Wend
    If Antriebaus = 1 Then
     ENick_Offset = Null_Nick
     Nick_Offset = Null_Nick
    end if
   End If
  End If

  Singdummy = U / 100
  Text = Fusing(singdummy , "#.&")
  Text = "Spannung= " + Text
  Text = Text + "V"
  Call DisplayLine(Text , 0 , 20 , Black , White)

  Singdummy = I / 10
  Text = Fusing(singdummy , "#.&")
  Text = "    Strom= " + Text
  Text = Text + "A"
  Call DisplayLine(Text , 0 , 29 , Black , White)

  Singdummy = Kmh / 10
  Text = Fusing(singdummy , "#.&")
  Text = "   Geschw= " + Text
  Text = Text + "km/h"
  Call DisplayLine(Text , 0 , 38 , Black , White)

  Singdummy = Meter / 1000
  Singdummy = Singdummy + Kilometer
  Text = Fusing(Singdummy , "#.###")
  Text = "   Gesamt= " + Text
  Text = Text + "km  "
  Call DisplayLine(Text , 0 , 47 , Black , White)

  Text = Str(SollSpeed)                                                         'PWM_Links
  Text = "PWM_Links= " + Text
  Call DisplayLine(Text , 0 , 56 , Black , White)

  Text = Str(SollRichtung)                                                      '0=Vorw. 1=Rckw. 2=Leerlauf
  Text = "Soll Richtg= " + Text
  Call DisplayLine(Text , 0 , 65 , Black , White)

  Text = Str(SollSpeed)                                                         '0=Vorw. 1=Rckw. 2=Leerlauf
  Text = "Soll Speed= " + Text
  Call DisplayLine(Text , 0 , 74 , Black , White)

  Text = Str(Akkustand)
  Text = "     Akku= " + Text
  Text = Text + "%"
  Call DisplayLine(Text , 0 , 83 , Black , White)

  Singdummy = Akkuverbraucht / 10
  Text = Fusing(singdummy , "#.&")
  Text = "AkkuVerb(mAh)= " + Text
  Call DisplayLine(Text , 0 , 92 , Black , White)

  Text = Str(Mit_Acc_Nick)
  Text = "     Nick= " + Text
  Call DisplayLine(Text , 0 , 101 , Black , White)

  Text = Str(Null_Nick)
  Text = "Null_Nick= " + Text
  Call DisplayLine(Text , 0 , 110 , Black , White)

  Text = "AusgabeTicks= " + Str(RueckAusgabeTicks_L)
  Call DisplayLine(Text , 0 , 119 , Black , White)

  Text = Str(RueckLoopCount)
  Text = "LoopCount= " + Text
  Call DisplayLine(Text , 0 , 128 , Black , White)

  'Text = Str(k_sum)
  'Text = "     Ksum= " + Text
  'Call DisplayLine(Text , 0 , 137 , Black , White)

 Case 4                                                                         'Min/Max Display
  If DateiAktuell = 1 Then
   If Bus_State_Rd = 1 Then Activate_sd_bus
   Close #2
   DateiAktuell = 0
  End If
  If Bus_State_Rd = 0 Then Call Activate_display_bus

  If Btn_Pu = 0 Then                                                            'Min-Maxwerte nullen
   Waitms 3
   If Btn_Pu = 0 Then
    While Btn_Pu = 0 : Wend
    Call Minmax
   End If
  End If
  Singdummy = Umin / 100
  Text = Fusing(Singdummy , "#.#")
  Text = "Umin= " + Text
  Text = Text + "V"
  Call DisplayLine(Text , 0 , 20 , Black , White)
  '**************************************************
  Singdummy = Umax / 100
  Text = Fusing(Singdummy , "#.#")
  Text = "Umax= " + Text
  Text = Text + "V"
  Call DisplayLine(Text , 0 , 29 , Black , White)
  '**************************************************
  Singdummy = Imin / 10
  Text = Fusing(Singdummy , "#.#")
  Text = "Imin= " + Text
  Text = Text + "A"
  Call DisplayLine(Text , 0 , 38 , Black , White)
  '**************************************************
  Singdummy = Imax / 10
  Text = Fusing(Singdummy , "#.#")
  Text = "Imax= " + Text
  Text = Text + "A"
  Call DisplayLine(Text , 0 , 47 , Black , White)
  '**************************************************
  Singdummy = Kmhmin / 10
  Text = Fusing(Singdummy , "#.#")
  Text = "Vmin= " + Text
  Text = Text + "km/h"
  Call DisplayLine(Text , 0 , 56 , Black , White)
  '**************************************************
  Singdummy = KmhMax / 10
  Text = Fusing(Singdummy , "#.#")
  Text = "Vmax= " + Text
  Text = Text + "km/h"
  Call DisplayLine(Text , 0 , 65 , Black , White)
  '**************************************************
  Text = Str(PWM_Links_Min )
  Text = "PWM_L_Min= " + Text
  Call DisplayLine(Text , 0 , 74 , Black , White)
  '**************************************************
  Text = Str(PWM_Links_Max )
  Text = "PWM_L_Max= " + Text
  Call DisplayLine(Text , 0 , 83 , Black , White)
  '**************************************************
  Text = Str(tamax )
  Text = "TAmax= " + Text
  Call DisplayLine(Text , 0 , 92 , Black , White)
  '**************************************************
   Text = Str(FussSchalter)
  Text = "FussSchalter= " + Text
  Call DisplayLine(Text , 0 , 101 , Black , White)
  '**************************************************
  Text = Str(FussCount)
  Text = "Fuss.Count= " + Text
  Call DisplayLine(Text , 0 , 110 , Black , White)

 Case 5                                                                         'Werte fr Hauptcontroller editieren
  If DateiAktuell = 1 Then
   If Bus_State_Rd = 1 Then Activate_sd_bus
   Close #2
   DateiAktuell = 0
  End If
  If Bus_State_Rd = 0 Then Call Activate_display_bus

  If Btn_Up = 0 Then                                                            'Zeile nach oben
   Waitms 3
   If Btn_Up = 0 Then
    While Btn_Up = 0 : Wend
    If EditState = 0 then
      If EditZeile > 1 Then
       Decr EditZeile
      Else
       EditZeile = 8
      End If
    end if
   End If
  End If

  If Btn_Dn = 0 Then                                                            'Zeile nach unten
   Waitms 3
   If Btn_Dn = 0 Then
    While Btn_Dn = 0 : Wend
    If EditState = 0 then
      If EditZeile < 9 Then
       Incr EditZeile
      Else
       EditZeile = 1
      End If
    end if
   End If
  End If

  '**************************************************
  Text = Str(Pfaktor)
  Text = "   P*10-4 = " + Text
  If EditZeile = 1 Then
   Call DisplayLine(Text , 0 , 20 , Black , Green)
  Else
   Call DisplayLine(Text , 0 , 20 , Black , White)
  End If

  Text = Str(Ifaktor)
  Text = "   I*10-6 = " + Text
  If EditZeile = 2 Then
   Call DisplayLine(Text , 0 , 29 , Black , Green)
  Else
   Call DisplayLine(Text , 0 , 29 , Black , White)
  End If

  Text = Str(Dfaktor)
  Text = "   D*10-2 = " + Text
  If EditZeile = 3 Then
   Call DisplayLine(Text , 0 , 38 , Black , Green)
  Else
   Call DisplayLine(Text , 0 , 38 , Black , White)
  End If

  Text = Str(mpfaktor)
  Text = "  MP*10-3 = " + Text
  If EditZeile = 4 Then
   Call DisplayLine(Text , 0 , 47 , Black , Green)
  Else
   Call DisplayLine(Text , 0 , 47 , Black , White)
  End If

  Text = Str(mvfaktor)
  Text = "  MV = " + Text
  If EditZeile = 5 Then
   Call DisplayLine(Text , 0 , 56 , Black , Green)
  Else
   Call DisplayLine(Text , 0 , 56 , Black , White)
  End If

  Text = Str(mplfaktor)
  Text = " MPL = " + Text
  If EditZeile = 6 Then
   Call DisplayLine(Text , 0 , 65 , Black , Green)
  Else
   Call DisplayLine(Text , 0 , 65 , Black , White)
  End If

  Text = Str(mvlfaktor)
  Text = " MVL = " + Text
  If EditZeile = 7 Then
   Call DisplayLine(Text , 0 , 74 , Black , Green)
  Else
   Call DisplayLine(Text , 0 , 74 , Black , White)
  End If

  Text = "V-Limit (Kmh): " + Str(VLimit)
  If EditZeile = 8 Then
   Call DisplayLine(Text , 0 , 83 , Black , Green)
  Else
   Call DisplayLine(Text , 0 , 83 , Black , White)
  End If

  Text = Str(RegelStrategie)
  Text = "0=P 1=PI 2=PID= " + Text
  If EditZeile = 9 Then
   Call DisplayLine(Text , 0 , 92 , Black , Green)
  Else
   Call DisplayLine(Text , 0 , 92 , Black , White)
  End If

  If Btn_Pu = 0 Then                                                            'Werte aus Display bernehmen und in EEPROM speichern
   Waitms 3
   If Btn_Pu = 0 Then
    While Btn_Pu = 0 : Wend
    Call PutEEpromData
   End If
  End If

 Case 6                                                                         'Werte fr Motorcontroller editieren
  If DateiAktuell = 1 Then
   If Bus_State_Rd = 1 Then Activate_sd_bus
   Close #2
   DateiAktuell = 0
  End If
  If Bus_State_Rd = 0 Then Call Activate_display_bus

  If Btn_Up = 0 Then                                                            'Zeile nach oben
   Waitms 3
   If Btn_Up = 0 Then
    While Btn_Up = 0 : Wend                                                     'Debounce
    If EditZeile > 1 Then
     Decr EditZeile
    Else
     EditZeile = 8
    End If
   End If
  End If

  If Btn_Dn = 0 Then                                                            'Zeile nach unten
   Waitms 3
   If Btn_Dn = 0 Then
    While Btn_Dn = 0 : Wend                                                     'Debounce
    If EditZeile < 7 Then
     Incr EditZeile
    Else
     EditZeile = 1
    End If
   End If
  End If

  '**************************************************
  Text = Str(StromRegPfaktor)
  Text = "I-RegP*10-4 = " + Text
  If EditZeile = 1 Then
   Call DisplayLine(Text , 0 , 20 , Black , Green)
  Else
   Call DisplayLine(Text , 0 , 20 , Black , White)
  End If

  Text = Str(StromRegIfaktor)
  Text = "I-RegI*10-4 = " + Text
  If EditZeile = 2 Then
   Call DisplayLine(Text , 0 , 29 , Black , Green)
  Else
   Call DisplayLine(Text , 0 , 29 , Black , White)
  End If

  Text = Str(StromGrenze)
  Text = "I-RegGrenze = " + Text
  If EditZeile = 3 Then
   Call DisplayLine(Text , 0 , 38 , Black , Green)
  Else
   Call DisplayLine(Text , 0 , 38 , Black , White)
  End If

  Text = Str(PWMmax)
  Text = "PWMmax= " + Text
  If EditZeile = 6 Then
   Call DisplayLine(Text , 0 , 47 , Black , Green)
  else
   Call DisplayLine(Text , 0 , 47 , Black , White)
  end if

  Text = Str(IBattmax)
  Text = "I-Batt Max(A)= " + Text
  If EditZeile = 7 Then
   Call DisplayLine(Text , 0 , 56 , Black , Green)
  else
   Call DisplayLine(Text , 0 , 56 , Black , White)
  end if

  If Btn_Pu = 0 Then                                                            'Werte aus Display bernehmen und in EEPROM speichern
   Waitms 3
   If Btn_Pu = 0 Then
    While Btn_Pu = 0 : Wend
    Call PutEEpromData
   End If
  End If

 Case 7                                                                         'Sinuswerte fr Motorcontroller editieren
  If DateiAktuell = 1 Then
   If Bus_State_Rd = 1 Then Activate_sd_bus
   Close #2
   DateiAktuell = 0
  End If
  If Bus_State_Rd = 0 Then Call Activate_display_bus

  If Btn_Up = 0 Then                                                            'Zeile aufwrts
   Waitms 3
   If Btn_Up = 0 Then
    While Btn_Up = 0 : Wend
    If EditZeile > 1 Then
     Decr EditZeile
    Else
     EditZeile = 12
    End If
   End If
  End If

  If Btn_Dn = 0 Then                                                            'Zeile abwrts
   Waitms 3
   If Btn_Dn = 0 Then
    While Btn_Dn = 0 : Wend
    If EditZeile < 12 Then
     Incr EditZeile
    Else
     EditZeile = 1
    End If
   End If
  End If

  If Btn_Pu = 0 Then                                                            'Werte aus Display bernehmen und in EEPROM speichern
   Waitms 3
   If Btn_Pu = 0 Then
    While Btn_Pu = 0 : Wend
    Call PutEEpromData
   End If
  End If

  For Idummy = 1 To 12
   Text = "Sinus" + Str(Idummy)
   Text = Text + " = "
   Text = Text + Str(Sinus(Idummy))
   L1 = Idummy * 9
   L1 = L1 + 11
   If Idummy = EditZeile Then
    Call DisplayLine(Text , 0 , L1 , Black , Green)
   Else
    Call DisplayLine(Text , 0 , L1 , Black , White)
   End If
  Next

 Case 8                                                                         'Rckdarstellung der Sinusparameter
  For Idummy = 1 To 12
   Text = "R-Sinus Li" + Str(Idummy)
   Text = Text + " = "
   Text = Text + Str(RueckSinusLinks(Idummy))
   L1 = Idummy * 9
   L1 = L1 + 11
   Call DisplayLine(Text , 0 , L1 , Black , White)
  Next

 Case 9                                                                         'Rckdarstellung div. Werte
  Text = "Ofs_Nick  = " + Str(RueckOffset_Nick)
  Call DisplayLine(Text , 0 , 20 , Black , White)

  Text = "O_nick_u  = " + Str(Rueck_O_Nick_u)
  Call DisplayLine(Text , 0 , 29 , Black , White)

  Text = "O_nick_o  = " + Str(Rueck_O_Nick_o)
  Call DisplayLine(Text , 0 , 38 , Black , White)

  Text = "O_nick_oo = " + Str(Rueck_O_Nick_oo)
  Call DisplayLine(Text , 0 , 47 , Black , White)

  Text = "Regelstrat= " + Str(RueckRegelstrategie)
  Call DisplayLine(Text , 0 , 56 , Black , White)

  Text = "PWMmax    = " + Str(RueckPWMmax)
  Call DisplayLine(Text , 0 , 65 , Black , White)

  Text = "StromReg-P= " + Str(RueckStromReg_Pfaktor)
  Call DisplayLine(Text , 0 , 74 , Black , White)

  Text = "StromReg-I= " + Str(RueckStromReg_Ifaktor)
  Call DisplayLine(Text , 0 , 83 , Black , White)

  Text = "Stromgrenz= " + Str(RueckStromGrenze)                                 '30 = 30A
  Call DisplayLine(Text , 0 , 92 , Black , White)

  Text = "I-Batt Max(A)= " + Str(IBattmax)
  Call DisplayLine(Text , 0 , 101 , Black , White)

  Text = "V-Limit(Kmh)= " + Str(RueckVlimit)
  Call DisplayLine(Text , 0 , 110 , Black , White)

  Text = "Richtung    = " + Str(RueckIstRichtung)                               '0=Vorw. 1=Rckw. 2=Leerlauf
  Call DisplayLine(Text , 0 , 119 , Black , White)

 Case 10                                                                        'SD. List 8.3 filenames of the root directory
  BDummy2 = 20                                                                  'Zeilennummer im Display
  DateiName = Dir( "*.log")                                                     'The first call to the DIR() function must contain a file mask
  BDummy = Len(DateiName)
  BDummy1 = 0
  While BDummy > 0                                                              'if file found
   Text = DateiName + " "
   LDummy = Filelen(DateiName)
   SingDummy = LDummy / 1024
   If SingDummy < 0.1 then SingDummy = 0.1                                      'KB
   Text = Text + Fusing(SingDummy , "#.#")
   Text = Text + "KB"
   If BDummy2 >= 157 then
    LCD_Print Str(BDummy1) + " more..." , 0 , BDummy2 , 1 , 1 , 1 , Black , White
    Exit While
   else
    LCD_Print Text , 0 , BDummy2 , 1 , 1 , 1 , Black , White
    BDummy2 = BDummy2 + 9
   End If
   Incr BDummy1
   Dateiname = Dir()                                                            'get next file
   BDummy = Len(DateiName)
  Wend

 Case 11                                                                        'Logging
  If Bus_State_Rd = 1 Then Activate_sd_bus
   If Antriebaus = 0 Then                                                       'Motoren laufen --> Werte loggen
    If DateiAktuell = 0 Then                                                    'Keine Datei geffnet
     Lname = 1
     Dateilaenge = 1                                                            'Nchste Schleife einmal erzwingen
     While Dateilaenge > 0                                                      'freien Dateinamen suchen
      Dateiname = Str(lname)
      Dateiname = Dateiname + ".log"
      '0 voranstellen, damit sich die Dateien besser sortieren lassen.
      While Len(Dateiname) < 12
       Dateiname = "0" + Dateiname
      Wend
      Dateilaenge = FileLen(Dateiname)                                          'File exists?
      Incr Lname
     Wend
     If Bus_State_Rd = 0 Then Call Activate_display_bus
     LCD_Print Dateiname , 25 , 55 , 1 , 1 , 1 , Black , White
     If Bus_State_Rd = 1 Then Activate_sd_bus
     DateiAktuell = 1
     Loopcount = 0
     _sec = 0
     _min = 0
     _hour = 0
     Zeit = "00:00:00"
     Open Dateiname For Append As #2
     Logtext = "Zeit;Loopcount;U;I;Nick;Sollspeed;Timer0Ticks;Rckausg.Ticks;Kmh;Akku%"
     Print #2 , Logtext
    End If
    If Loopcount <> AloopCount Then
     Logtext = Zeit
     Logtext = Logtext + ";"
     Logtext = Logtext + Str(LoopCount)
     Logtext = Logtext + ";"
     Singdummy = U / 100
     Logtext = Logtext + Fusing(SingDummy , "#.#")
     Logtext = Logtext + ";"
     Singdummy = I / 10
     Logtext = Logtext + Fusing(SingDummy , "#.#")
     Logtext = Logtext + ";"
     Logtext = Logtext + Str(Mit_Acc_Nick)
     Logtext = Logtext + ";"
     Logtext = Logtext + Str(SollSpeed)
     Logtext = Logtext + ";"
     Logtext = Logtext + Str(ta)
     Logtext = Logtext + ";"
     Logtext = Logtext + Str(RueckAusgabeTicks_L)
     Logtext = Logtext + ";"
     Singdummy = Kmh / 10
     Logtext = Logtext + Fusing(SingDummy , "#.#")
     Logtext = Logtext + ";"
     Logtext = Logtext + Str(Akkustand)
     Print #2 , Logtext
     Aloopcount = Loopcount
     Incr LoopCount
    End If
   Else
    Close #2
    DateiAktuell = 0
    If Loopcount = 0 then
     Kill Dateiname                                                             'Es wurden keine Daten gespeichert
    else
     Call LCD_Print( "File closed" , 0 , 140 , 1 , 1 , 1 , White , Black)
    end if
   End If
 End Select
Loop

Sub DisplayEditLine(byval ConstStr as String , Variable as Long)
 Local Text as String * 22
 Local x as Byte

 If EditZeile = 1 and EditState = 1 Then
   EditStr = Str(Variable)
   'Static text
   x = Spalte - 1
   Text = Left(EditStr , x)
   Call DisplayLine(Text , 0 , 20 , Black , Yellow)
   'Highlighted character
   Text = Mid(EditStr , Spalte , 1)
   Call DisplayLine(Text , 0 , 20 , Black , Green)
   'Static text
   x = Spalte + 1
   Text = Mid(EditStr , x , 22)
   Call DisplayLine(Text , 0 , 20 , Black , Yellow)
  Else
   Text = Str(Pfaktor)
   Text = ConstStr + Str(Variable)
   Call DisplayLine(Text , 0 , 20 , Black , White)
  End If
end Sub

'***************************************************************************
Datenempfang:
 'Die empfangenen Zeichen im nach links laufenden Umlauf in Empfpuffer(x) geschrieben
 'Dadurch wir sichergestellt, dass das gesendete Endezeichen (CR) als
 'Startzeichen irgendwann im Ep0 steht

 'Zeichen im Puffer nach links schieben
 !LDS R24,{Ep1}                                                                 'Load Direct from data space @address xxx
 !STS {Ep0},R24                                                                 'Write Rxx to address loaction
 !LDS R24,{Ep2}                                                                 'Load Direct from data space @address xxx
 !STS {Ep1},R24                                                                 'Write Rxx to address loaction
 !LDS R24,{Ep3}                                                                 'Load Direct from data space @address xxx
 !STS {Ep2},R24                                                                 'Write Rxx to address loaction
 !LDS R24,{Ep4}                                                                 'Load Direct from data space @address xxx
 !STS {Ep3},R24                                                                 'Write Rxx to address loaction
 !LDS R24,{Ep5}                                                                 'Load Direct from data space @address xxx
 !STS {Ep4},R24                                                                 'Write Rxx to address loaction
 !LDS R24,{Ep6}                                                                 'Load Direct from data space @address xxx
 !STS {Ep5},R24                                                                 'Write Rxx to address loaction
 !LDS R24,{Ep7}                                                                 'Load Direct from data space @address xxx
 !STS {Ep6},R24                                                                 'Write Rxx to address loaction
 !LDS R24,{Ep8}                                                                 'Load Direct from data space @address xxx
 !STS {Ep7},R24                                                                 'Write Rxx to address loaction
 !LDS R24,{Ep9}                                                                 'Load Direct from data space @address xxx
 !STS {Ep8},R24                                                                 'Write Rxx to address loaction
 !LDS R24,{Ep10}                                                                'Load Direct from data space @address xxx
 !STS {Ep9},R24                                                                 'Write Rxx to address loaction
 #if DisplayType = "D071x"
  !IN  R24,UDR1                                                                 'neues Zeichen einlese
 #endif
 #if DisplayType = "D074x"
  !IN  R24,UDR                                                                  'neues Zeichen einlese
 #endif
 !STs {Ep10},R24                                                                'Write Rxx to address loaction

  'Message prfen
 If Ep0 = 13 And Ep10 = 13 Then                                                 'Message gltig
  'BCC prfen
  !lds R24,{EP1}                                                                'Index
  !LDs R25,{EP2}
  !add R24,R25
  !LDs R25,{EP3}
  !add R24,R25
  !LDs R25,{EP4}
  !add R24,R25
  !LDs R25,{EP5}
  !add R24,R25
  !LDs R25,{EP6}
  !add R24,R25
  !LDs R25,{EP7}
  !add R24,R25
  !LDs R25,{EP8}
  !add R24,R25
  !STS {Bdummy},R24

  If Bdummy = EP9 then                                                          'Die Prfsumme stimmt
   Select Case Ep1                                                              'Telegrammnummer
    Case &H65                                                                   '101
     Kmh1 = EP2                                                                 'Kmh
     Kmh2 = EP3
     If Kmh > 990 then                                                          'in 0,1Kmh Schritten
      Kmh = 990
     elseIf Kmh < -990 then
      Kmh = -990
     end if
     AkkuStand = EP4                                                            'in %
     Kilometer1 = EP5                                                           'Kilometer
     Kilometer2 = EP6
     Meter1 = EP7                                                               'Meter
     ' = EP8
    Case &H66                                                                   '102
     Meter2 = EP2
     FussSchalter = EP3                                                         'FussSchalter
     ErrorWord1 = EP4
     ErrorWord2 = EP5
     U1 = EP6
     U2 = EP7
     ' = EP8
    Case &H67                                                                   '103
     I = EP2
     Ta = EP3
     Antriebaus = EP4
     KK_Temp_Links1 = EP5
     KK_Temp_Links2 = EP6
     RueckIstRichtung = EP7
     ' = EP8
    Case &H68                                                                   '104
     RueckLoopCount1 = EP2
     RueckLoopCount2 = EP3
     ' = EP4
     ' = EP5
     ' = EP6
     ' = EP7
     ' = EP8
    Case &H69                                                                   '105
     If Antriebaus = 1 Then
      NullNick1 = EP2                                                           'Nullwert der Neigung vorwrts
      NullNick2 = EP3
      NullNick3 = EP4
      NullNick4 = EP5
      Null_Nick = NullNick
     Else
      Mit_AccNick1 = EP2                                                        'Mittelwert der Neigung vorwrts
      Mit_AccNick2 = EP3
      Mit_AccNick3 = EP4
      Mit_AccNick4 = EP5
      Mit_Acc_Nick = Mit_AccNick
     end if
     RueckAusgabeTicks_L1 = EP6
     RueckAusgabeTicks_L2 = EP7
     ' = EP8
    Case &H6A                                                                   '106
     RueckSinusLinks(1) = EP2
     Ruecksinuslinks(2) = EP3
     Ruecksinuslinks(3) = EP4
     Ruecksinuslinks(4) = EP5
     Ruecksinuslinks(5) = EP6
     Ruecksinuslinks(6) = EP7
     ' = EP8
    Case &H6B                                                                   '107
     Ruecksinuslinks(7) = EP2
     Ruecksinuslinks(8) = EP3
     Ruecksinuslinks(9) = EP4
     Ruecksinuslinks(10) = EP5
     Ruecksinuslinks(11) = EP6
     Ruecksinuslinks(12) = EP7
     ' = EP8
    Case &H6C                                                                   '108
     RueckStromgrenze = EP2                                                     'in 1A Schritten
     RueckVlimit = EP3
     RueckRegelstrategie = EP4
     RueckPWMmax = EP5
     ' = EP6
     ' = EP7
     ' = EP8
    Case &H6D                                                                   '109
     RueckStromReg_Pfaktor1 = EP2
     RueckStromReg_Pfaktor2 = EP3
     RueckStromReg_Pfaktor3 = EP4
     RueckStromReg_Pfaktor4 = EP5
     RueckStromReg_Ifaktor1 = EP6
     RueckStromReg_Ifaktor2 = EP7
     RueckStromReg_Ifaktor3 = EP8
     ' = EP8
    Case &H6E                                                                   '110
     RueckStromReg_Ifaktor4 = EP2
     '= EP3
     '= EP4
     RueckOffsetNick1 = EP5
     RueckOffsetNick2 = EP6
     RueckOffsetNick3 = EP7
     RueckOffsetNick4 = EP8
     RueckOffset_Nick = RueckOffsetNick
    Case &H6F
     Rueck_Onicku1 = EP2
     Rueck_Onicku2 = EP3                                                        '111
     Rueck_Onicku3 = EP4
     Rueck_Onicku4 = EP5
     Rueck_O_nick_u = Rueck_Onicku
     Rueck_Onicko1 = EP6
     Rueck_Onicko2 = EP7
     Rueck_Onicko3 = EP8
    Case &H70                                                                   '112
     Rueck_Onicko4 = EP2
     Rueck_O_nick_o = Rueck_Onicko
     Rueck_Onickoo1 = EP3
     Rueck_Onickoo2 = EP4
     Rueck_Onickoo3 = EP5
     Rueck_Onickoo4 = EP6
     Rueck_O_nick_oo = Rueck_Onickoo
     ' = EP7
     ' = EP8
    Case &H71                                                                   '113
     Comerrorsdisplay1 = EP2
     Comerrorsdisplay2 = EP3
     Akkuverbraucht1 = EP4
     Akkuverbraucht2 = EP5
     Comerrorsmotlinks1 = EP6
     Comerrorsmotlinks2 = EP7
     FussCount = EP8
    Case &H72                                                                   '114
     Startup1 = EP2
     Startup2 = EP3
     NotausGrund = EP4
     MsgStrIndex = EP5                                                          '0...x
     ' = EP6
     ' = EP7
     ' = EP8
    Case MotorID_L
     Incr Loopcount
     If EP2 < &H04 then                                                         '0..3 ==> Antriebsdaten
      SollRichtung = EP2                                                        'Richtung
      SollSpeed = EP3                                                           'PWM Breite
      ' = EP4
      ' = EP5
      ' = EP6
      ' = EP7
      ' = EP8
     End If
    Case &HFE
     LongTxData(1) = 57 + 2                                                     'Anzahl Datenbyte inkl. BCC und CR
     LongTxData(2) = Sinus(1)
     LongTxData(3) = Sinus(2)
     LongTxData(4) = Sinus(3)
     LongTxData(5) = Sinus(4)
     LongTxData(6) = Sinus(5)
     LongTxData(7) = Sinus(6)
     LongTxData(8) = Sinus(7)
     LongTxData(9) = Sinus(8)
     LongTxData(10) = Sinus(9)
     LongTxData(11) = Sinus(10)
     LongTxData(12) = Sinus(11)
     LongTxData(13) = Sinus(12)
     LongTxData(14) = StromReg_Pfaktor1
     LongTxData(15) = StromReg_Pfaktor2
     LongTxData(16) = StromReg_Pfaktor3
     LongTxData(17) = StromReg_Pfaktor4
     LongTxData(18) = StromReg_Ifaktor1
     LongTxData(19) = StromReg_Ifaktor2
     LongTxData(20) = StromReg_Ifaktor3
     LongTxData(21) = StromReg_Ifaktor4
     LongTxData(22) = Regelstrategie
     LongTxData(23) = PWMmax
     LongTxData(24) = P_faktor1
     LongTxData(25) = P_faktor2
     LongTxData(26) = P_faktor3
     LongTxData(27) = P_faktor4
     LongTxData(28) = I_faktor1
     LongTxData(29) = I_faktor2
     LongTxData(30) = I_faktor3
     LongTxData(31) = I_faktor4
     LongTxData(32) = D_faktor1
     LongTxData(33) = D_faktor2
     LongTxData(34) = D_faktor3
     LongTxData(35) = D_faktor4
     LongTxData(36) = Mp_faktor1
     LongTxData(37) = Mp_faktor2
     LongTxData(38) = Mp_faktor3
     LongTxData(39) = Mp_faktor4
     LongTxData(40) = Mv_faktor1
     LongTxData(41) = Mv_faktor2
     LongTxData(42) = Mv_faktor3
     LongTxData(43) = Mv_faktor4
     LongTxData(44) = Mpl_faktor1
     LongTxData(45) = Mpl_faktor2
     LongTxData(46) = Mpl_faktor3
     LongTxData(47) = Mpl_faktor4
     LongTxData(48) = Mvl_faktor1
     LongTxData(49) = Mvl_faktor2
     LongTxData(50) = Mvl_faktor3
     LongTxData(51) = Mvl_faktor4
     LongTxData(52) = Strom_Grenze
     LongTxData(53) = Vlimit                                                    '22 = 22Kmh
     NickOffset = Nick_Offset
     LongTxData(54) = NickOffset1
     LongTxData(55) = NickOffset2
     LongTxData(56) = NickOffset3
     LongTxData(57) = NickOffset4
     Call SendMessage2COM                                                       'Send Long Data to Main Controller
   End Select
  End If                                                                        'BCC ist Ok
 End If                                                                         'Message eingegangen
Return

'***************************************************************************
Sub SendMessage2COM
 Local n as Byte
 Local B as Byte
 Local i as Byte

 BDummy = 0
 i = LongTxData(1) - 2
 For n = 1 to i
  B = LongTxData(n)
  BDummy = BDummy + B                                                           'BCC
  #if DisplayType = "D071x"
   Printbin #1 , B;                                                             'Daten
  #endif
  #if DisplayType = "D074x"
   Printbin B;                                                                  'Daten
  #endif
 Next
 #if DisplayType = "D071x"
   Printbin #1 , BDummy ; 13;                                                   'BCC und CR
  #endif
  #if DisplayType = "D074x"
   Printbin BDummy ; 13;                                                        'BCC und CR
  #endif
End Sub

'***************************************************************************
Sub Activate_Display_Bus
'(Config SPI will not work in Bascom 1.06.x and up, when called a second time
  Config Spi = Hard , Interrupt = Off , Data Order = Msb , Master = Yes , Polarity = Low , Phase = 0 , _
         Clockrate = 4 , Noss = 1
  Set Spsr.spi2x       'hidden parameter: doubles the speed of the SPI output
  Spiinit

   >>>>>>>>>>>> Workaround for Config SPI <<<<<<<<<<<<<<<<<
  *** SPCR SPI CONTROL REGISTER ***
  0 = SPR0: SPI Clock Rate Select 1 and 0
  1 = SPR1
              SPI2X SPR1 SPR0 SCK Frequency
               0     0     0  fosc /4
               0     0     1  fosc /16
               0     1     0  fosc /64
               0     1     1  fosc /128
               1     0     0  fosc /2
               1     0     1  fosc /8
               1     1     0  fosc /32
               1     1     1  fosc /64
  2 = CPHA: Clock Phase 0 or 1
  3 = CPOL: Clock Polarity, 0 = Rising Falling(Low), 1 = Falling Rising(High)
  4 = MSTR: Master/Slave Select  Master SPI mode = 1, Slave SPI mode = 0
  5 = DORD: MSB first = 0, LSB first = 1
  6 = SPE : SPI Enable = 1
  7 = SPIE: SPI Interrupt Enable = 1

 In SPI mode, speed is not guaranteed by specification, but the minimum supported 4-bit bus mode clock speed is
 12,5 MHz. The maximum SPI speed for AVR 8-bit is 10MHz, so we set SPI to maximum speed, f osc / 2
')
 Reset Bus_State_Wr                                                             'Remove SD Card from bus
 Spcr = &B01010000
 Set Spsr.spi2x
 'Don't call Spiinit again
End Sub

'***************************************************************************
Sub Activate_SD_Bus
 Set Lcd_port.lcd_cs                                                            'High ==> Deactivate Display

'(Config SPI will not work in Bascom 2.0.7.6 and up, when called a second time
  Config Spi = Hard , Interrupt = Off , Data Order = Msb , Master = Yes , Polarity = High , Phase = 1 , _
         Clockrate = 4 , Noss = 1
  Reset Spsr.spi2x
  Spiinit

 Workaround for Config SPI: See above
')
 Spcr = &B01011100
 Reset Spsr.spi2x
 'Don't call Spiinit again
 Set Bus_State_Wr                                                               'Activate SD Tristate chip
End Sub

'***************************************************************************
Sub DisplayLine(t As String , Byval X As Byte , Byval Y As Byte , _
                 Byval Txtcolor As Word , Byval Bgrcolor As Word)
 If Len(t) > 22 Then
  T = Left(t , 22)
 Else
  While Len(t) < 22
   T = T + " "
  Wend
 End If
 LCD_Print Text , X , Y , 1 , 1 , 1 , Txtcolor , Bgrcolor
End Sub

'***************************************************************************
Sub DisplayStatusLine(Txt As String , Byval X As Byte , Byval Y As Byte , _
                      Byval Txtcolor As Word , Byval Bgrcolor As Word)
'Line above base line of main Page display
 Local Text As String * 19

 Text = Txt
 If Len(Text) > 19 Then
  Text = Left(Text , 19)
 Else
  While Len(Text) < 19
   Text = Text + " "
  Wend
 End If
 LCD_Print Text , X , Y , 1 , 1 , 1 , Txtcolor , Bgrcolor
End Sub

'***************************************************************************
Sub Minmax
 Umin = 10000
 Umax = -10000
 Imin = 0
 Imax = 0
 Kmhmin = 0
 KmhMax = 0
 PWM_Links_Max = 0
 PWM_Links_Min = 0
 Tamax = 0
End Sub

'***************************************************************************
Tick:
 Incr _sec
 If _sec > 59 Then
  _sec = 0
  Incr _min
 End If

 If _min > 59 Then
  _min = 0
  Incr _hour
 End If

 Zeit = Time$
Return

'***************************************************************************
Sub Drawpagestatics(Byval PageNum as Byte)
 Local X As Byte
 Local Y As Byte

 Text = Titel + Str(PageNum)
 Call DisplayLine(Text , 0 , 0 , Yellow , Blue)

 Select Case Modus
  Case 0
   Text = "Start Display"
   Call DisplayLine(Text , 0 , 9 , Black , Yellow)

  Case 1
   LCD_Rect 8 , 84 , 124 , 95 , 0 , Black                                       'Rahmen fr Akku Balken

   LCD_Rect 8 , 100 , 19 , 160 , 0 , Black                                      'Rahmen fr Vertikal Lenker
   LCD_Draw 20 , 130 , 22 , 130 , 0 , Black                                     'Vertikaler Balken, Mitteltick

   LCD_Draw 0 , 167 , 132 , 167 , 0 , Black                                     'Hintergrund der Fuzeile

  Case 2
   Text = "Fehler bzw. Status"
   Call DisplayLine(Text , 0 , 9 , Black , Yellow)

  Case 3
   Text = "Details"
   Call DisplayLine(Text , 0 , 9 , Black , Yellow)

  Case 4
   Text = "Min- / Max- Werte"
   Call DisplayLine(Text , 0 , 9 , Black , Yellow)

  Case 5
   Text = "Lagereglerparameter"
   Call DisplayLine(Text , 0 , 9 , Black , Yellow)

  Case 6
   Text = "Mot-Regelparameter"
   Call DisplayLine(Text , 0 , 9 , Black , Yellow)

  Case 7
   Text = "Sinussollwerte"
   Call DisplayLine(Text , 0 , 9 , Black , Yellow)

  Case 8
   Text = "Rckdarst.Sinus"
   Call DisplayLine(Text , 0 , 9 , Black , Yellow)

  Case 9
   Text = "Rckdarst.Gyro"
   Call DisplayLine(Text , 0 , 9 , Black , Yellow)

  Case 10
   Text = "SD-DIR"
   Call DisplayLine(Text , 0 , 9 , Black , Yellow)
  Case 11
   Call LCD_Print( "LOGGING" , 30 , 20 , 2 , 1 , 2 , Black , White)
   'LCD_Print Dateiname , 25 , 55 ....
   Call LCD_Print( "Close file by dis-" , 0 , 80 , 1 , 1 , 1 , Black , White)
   Call LCD_Print( "abling RUN while on" , 0 , 90 , 1 , 1 , 1 , Black , White)
   Call LCD_Print( "this page" , 0 , 100 , 1 , 1 , 1 , Black , White)
   DateiAktuell = 0
 End Select
End Sub

'***************************************************************************
Sub PutEEpromData()
 Local tempn as Byte

 Call ChangeDecimal(0)                                                          'convert Long to Single
 EStartkilometer = Startkilometer
 ENick_Offset = Null_Nick
 For tempn = 1 to 12
  ESinus(tempn) = Sinus(tempn)
 next
 EIBattMax = IBattMax
 EP_faktor = P_faktor
 EI_faktor = I_faktor
 ED_faktor = D_faktor
 EMp_faktor = Mp_faktor
 EMv_faktor = Mv_faktor
 EMpl_faktor = Mpl_faktor
 EMvl_faktor = Mvl_faktor
 ERegelstrategie = Regelstrategie
 EPWMmax = PWMmax
 EStromReg_Pfaktor = StromReg_Pfaktor
 EStromReg_Ifaktor = StromReg_Ifaktor
 EStrom_Grenze = Strom_Grenze
 EVLimit = VLimit

 Call Lcd_cls
 LCD_Print "Werte in" , 0 , 20 , 2 , 1 , 1 , Black , Red
 LCD_Print "EEPROM" , 0 , 40 , 2 , 1 , 1 , Black , Red
 LCD_Print "gespeichert" , 0 , 60 , 2 , 1 , 1 , Black , Red

 Call GetEEpromData
 Wait 2
 Call LCD_cls
 Call Drawpagestatics(Modus)
End Sub

'***************************************************************************
Sub GetEEpromData()
 Local tempn as Byte

 Startkilometer = EStartkilometer
 Nick_Offset = ENick_Offset
 Null_Nick = Nick_Offset
 For Tempn = 1 to 12
  Sinus(tempn) = ESinus(tempn)
 next
 StromReg_Pfaktor = EStromReg_Pfaktor
 StromReg_Ifaktor = EStromReg_Ifaktor
 Strom_Grenze = EStrom_Grenze
 P_faktor = EP_faktor
 I_faktor = EI_faktor
 D_faktor = ED_faktor
 Mp_faktor = EMp_faktor
 Mv_faktor = EMv_faktor
 Mpl_faktor = EMpl_faktor
 Mvl_faktor = EMvl_faktor
 Regelstrategie = ERegelstrategie
 PWMmax = EPWMmax
 VLimit = EVLimit
 IBattMax = EIBattMax

 Call ChangeDecimal(1)                                                          'convert to Long

 If Regelstrategie > 100 then Regelstrategie = 0
end sub

'***************************************************************************
Sub ChangeDecimal(byval Up As Byte)
 If Up = 1 Then                                                                 'Convert to Long
  SingDummy = P_faktor * 10000
  SingDummy = Round(SingDummy)
  Pfaktor = SingDummy

  SingDummy = I_faktor * 1000000
  SingDummy = Round(SingDummy)
  Ifaktor = SingDummy

  SingDummy = D_faktor * 1000
  SingDummy = Round(SingDummy)
  Dfaktor = SingDummy

  SingDummy = Mp_faktor * 10000
  SingDummy = Round(SingDummy)
  Mpfaktor = SingDummy

  SingDummy = Mv_faktor * 1000
  SingDummy = Round(SingDummy)
  Mvfaktor = SingDummy

  SingDummy = Mpl_faktor * 10000
  SingDummy = Round(SingDummy)
  Mplfaktor = SingDummy

  SingDummy = Mvl_faktor * 1000
  SingDummy = Round(SingDummy)
  Mvlfaktor = SingDummy

  SingDummy = StromReg_Pfaktor * 10000
  SingDummy = Round(SingDummy)
  StromRegPfaktor = SingDummy

  SingDummy = StromReg_Ifaktor * 100000
  SingDummy = Round(SingDummy)
  StromRegIfaktor = SingDummy

  StromGrenze = Strom_Grenze
 Else                                                                           'Convert to Single
  P_faktor = Pfaktor / 10000
  I_faktor = Ifaktor / 1000000
  D_faktor = Dfaktor / 1000
  Mp_faktor = Mpfaktor / 10000
  Mv_faktor = Mvfaktor / 1000
  Mpl_faktor = Mplfaktor / 10000
  Mvl_faktor = Mvlfaktor / 1000
  StromReg_Pfaktor = StromRegPfaktor / 10000
  StromReg_Ifaktor = StromRegIfaktor / 1000000
  Strom_Grenze = StromGrenze
 End If
End Sub

'***************************************************************************
GetDateTime:
 'Nothing yet
Return

$include "C:\Programme\Tools\BASCOM-AVR\Display 3000\Displaymodul\Bascom Programme\fr Include\GLCD21_display3000.bas"
$include "C:\Programme\Tools\BASCOM-AVR\Display 3000\Displaymodul\Bascom Programme\fr Include\GLCD21_fonts.bas"

Colortable:
 Data 0